--
-- honkanim
-- Specialization for T150
--
-- @author  	_-OverClocker-_
-- @version 	v1.0
-- @date  		04/03/20

honkanim= {};

function honkanim.prerequisitesPresent(specializations)
    return 
	SpecializationUtil.hasSpecialization(Motorized, specializations) and 
	SpecializationUtil.hasSpecialization(Enterable, specializations) and 
	SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations) and  
	SpecializationUtil.hasSpecialization(Drivable, specializations);
end;

function honkanim.registerEventListeners(vehicleType)	
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", honkanim);
	SpecializationUtil.registerEventListener(vehicleType, "onUpdateTick", honkanim)
end

function honkanim.registerFunctions(vehicleType)
    SpecializationUtil.registerFunction(vehicleType, "playhonkAnim", honkanim.playhonkAnim)
end

function honkanim:onLoad(savegame)
    
    local baseString = string.format("vehicle.honk.");
    self.honkAnim = {};
    if hasXMLProperty(self.xmlFile, "vehicle.honk.honkkey") then
        self.honkAnim.honkanim= {};
        i=0;
        while true do
            self.honkAnim.honkanim[i] = getXMLString(self.xmlFile,baseString..string.format("honkkey.honk#animName%d", i));
            if self.honkAnim.honkanim[i] == nil then
                break;
            end;
            i=i+1;
        end;
    end;
end;
function honkanim:onUpdateTick(dt)
    if self:getIsActive() then
        if self.spec_honk.isPlaying then
            self:playhonkAnim(self.honkAnim.honkanim[0], 1);
        else
            self:playhonkAnim(self.honkAnim.honkanim[0], -1);
		end;
	end;
end;

function honkanim:playhonkAnim(animName, animSpeed)    
    local animTime = self:getAnimationTime(animName);
    if not self:getIsAnimationPlaying(animName) then    
        self:playAnimation(animName, animSpeed, animTime, true);
    end;
end;